// THIS FUNCTION COMBINES X AND Y DISPLAY
// BOTH AXIS ARE SCROLLING ACCORDING TO THE INPUT VARIABLES
// X-AXIS SCROLLS PERIODICALLY, hence pxscrollplot

//var1: 1xn vector             --> Xdata
//var2: 1xn vector             --> Ydata
//var3: string                 --> Xdata name
//var4: string                 --> Ydata name
//var5: string                 --> Xdata unit
//var6: string                 --> Ydata unit


function pxscrollplot (X,Y, Xname, Yname, Xunit, Yunit);

    END    = max(size(X));

    fignr = 1010;                       // use big numbers, so normal figures won't be affected

    f = figure(fignr);                  // change figure settings according to OS-language
    delmenu(fignr,'Datei');
    delmenu(fignr,'Zusatzprogramme');
    delmenu(fignr,'Editieren');
    delmenu(fignr,'?');
    toolbar(fignr,'off');
    f.background        = 1;                // black background
    f.figure_size       = [350 350];
    f.figure_name       = Yname + ' over ' + Xname ;
    f.figure_position   = [700 300];


    x = 30;
    y = 100;                // <-- you may set the scale borders here
    w = 50;                 // <-- use "w" to set the x-position of the x-axis label
    h = 15;                 // <-- use "h" to set the y-position of the y-axis label

    // display actual data

    for i=1:END;
  
        // define x-axis
        XC = X(i);                 // defining the center of the x-axis
        
        // count how many times actual data is > than period
        period = 360;
        n = floor(XC/period);
       
        XC = XC-period*n;
        

	// for checkin purposes
        // mprintf('index = %.2f, DATA(i) = %.2f, n = %.2f, calc. heading = %.2f \n', i,(X(i)),(n),(XC));

        Xt = -period:10:period;                     // ticks in 10° steps
       
        drawlater(); 
        if  i >1 & i < END+1;
            drawlater();
            delete(e1);
            delete(e2);
            e1 = a.children(1); 
            e1.thickness = 2;  
            e2 = a.children(2); 
            e2.thickness = 2; 

        end
        xpoly([XC XC],[Y(i)-y/2 Y(i)+y/2],'lines',1);
        xpoly([XC-x/2 XC+x/2],[Y(i) Y(i)],'lines',1);

        a = gca();
        a.x_location = "bottom";
        a.y_location = "right";
        a.margins = [0.2,0.2,0.2,0.2];    
        a.axes_visible = ["on","on","off"];
        a.data_bounds = [XC-x, Y(i)-y; XC+x, Y(i)+y];
        a.tight_limits = "on";
        e1 = a.children(1); 
        e1.thickness = 2;  
        e2 = a.children(2); 
        e2.thickness = 2; 

        a.foreground                = 7;            // normal display = yellow
        a.font_foreground           = 7;
        a.font_size                 = 3;

        a.x_label.font_foreground   = 7;
        a.x_label.text = Xname + ' ' + Xunit;
        a.x_label.font_angle = 0;
        a.x_label.font_size = 2;
        a.x_label.position = [XC-x Y(i)-y-50];

        a.y_label.font_foreground   = 7;
        a.y_label.text = Yname + ' ' + Yunit;
        a.y_label.font_angle = 0;
        a.y_label.font_size = 2;
        a.y_label.position = [XC+x Y(i)+y+h];
        a.ticks_format = ["%d","%d",""];

        a.x_ticks = tlist(["ticks" "locations" "labels"],Xt,string(pmodulo(Xt,period)));
        a.sub_ticks(1) = 1;
        a.sub_ticks(2) = 4;

        drawnow();
        drawnow(); 


        // for checking purpose
        // mprintf('value = %.2f, lower scale = %.2f, upper scale = %.2f \n', data(i),data(i)-y,data(i)+y);
        
	tstep = 50;
        xpause(tstep*1000);  // xpause counts in microseconds, tstep is for milliseconds, thatswhy factor 1000




    end

endfunction
