//THIS FUNCTION WILL CREATE A ANALOGUE LIKE DISPLAY OF THE INPUT DATA
//
//var1: 1xn vector             --> data to be displayd
//var2: integer                --> maximum value to be displayed

// more parameters can be changed within the function..see comments.

function tachometer(data, scale);

    CENTER = [0 0];
    END   = max(size(data));

    start_pos = scale / 2;      // this is to have the needle start at left position

    // create a new figure and delete all the menues and the toolbox                
    fignr = 1000;       // use big numbers, so normal figures won't be affected

    f = figure(fignr);
    delmenu(fignr,'Datei');
    delmenu(fignr,'Zusatzprogramme');
    delmenu(fignr,'Editieren');
    delmenu(fignr,'?');
    toolbar(fignr,'off');

    // define the display settings here
    f.background = 1;
    f.figure_size = [300;300];
    f.figure_name = 'tachometer';
    f.figure_position = [200;300];

    display_color = 1;
    drawlater();
    // define a symmetric box, so that arc is a circle
    rect=[-1,-1,1,1];
    plot2d(0,0,0,rect=rect,frameflag=3,axesflag=5);     
    a = gca();
    a.visible = "on";
    a.box = "off";
    a.data_bounds = [-1.2,0;1.2,1.2];       // play with these parameters to maybe see the full circle
    a.axes_bounds = [0,0,1,1];
    a.margins = [0,0,0,0];
    a.axes_visible = ["off","off","off"];
    a.x_location = "bottom";
    a.axes_reverse = ["off","off","off"];   // play with this around, so you can change the orientation of the tachometer

    // plot the arc
    // NOTE: without the arc the design is more like a clock
    //          --> than - by use of 3 needles - one could create a watch


    xset("color",display_color);
    xfarc(-1,1,2,2,0,1000*scale);                           // draw the arc


    // define the grid of the arc
    GRID = linspace(1,scale,scale/10+1);
    // plot the arc and define its properties
    plot ([CENTER(1) CENTER(1)+sin((GRID-start_pos)*%pi/scale)],[CENTER(2) CENTER(2)+cos((GRID-start_pos)*%pi/scale)],'o');
    a = gca();
    a.axes_visible = ["off","off","off"];
    e=gce();
    p=e.children(1);

    n = length (GRID);
    // define GRID labels (datatips)
    function str=myfmt(curve, pt, index)
        if i == 1 then;
            str = msprintf('%d', 0);
        else;
            str = msprintf('%d', GRID(i));
        end;
    endfunction  
    datatipSetDisplay(p,myfmt);
    for i = 1:n;
        if i == 1 then;
            t = datatipCreate(p,i+1);
            datatipSetOrientation(t,"upper left");  // set to "lower right" otherwise
        else;
            t = datatipCreate(p,i+1);
            datatipSetOrientation(t,"automatic");        
        end;
    end;

    // define the tachometer needle here
    needle_style        = 1;
    needle_thickness    = 3;
    needle_length       = 0.8;

    drawnow();

    for i=1:END;
        drawlater();
        if  i >1 & i < END+1;
            drawlater();
            delete(e);
        end;

        if data(i) > scale
            needle_color        = 5;     // red needle if it exceeds max display
            xset("color",needle_color);
        else
            needle_color        = 7;    // yellow needle 
            xset("color",needle_color);
        end



        xpoly([CENTER(1) CENTER(1)+sin((speed(i)-start_pos)*%pi/scale)*needle_length],[CENTER(2) CENTER(2)+cos((speed(i)-start_pos)*%pi/scale)*needle_length],'lines',0);
        e = gce();
        e.thickness  = needle_thickness;    
        e.line_style = needle_style;

        drawnow();
        drawnow();

        tstep = 50;
        xpause(tstep*1000);  // xpause counts in microseconds, tstep is for milliseconds, thatswhy factor 1000

    end;


endfunction;



