//THIS FUNCTION WILL CREATE A VARIOMETER LIKE DISPLAY OF THE INPUT DATA
//
//var1: 1xn vector             --> data to be displayd
//var2: string                 --> data unit
//var3: double                 --> lower limit in [%] to change display color
//var4: [1x2] matrix           --> upper limit in [%] to change display color


function variometer (data,unit, low_lim, up_lim)

    CENTER = [0 0];
    END    = max(size(data));

    fignr = 1001;       // use big numbers, so normal figures won't be affected

    f = figure(fignr);
    delmenu(fignr,'Datei');
    delmenu(fignr,'Zusatzprogramme');
    delmenu(fignr,'Editieren');
    delmenu(fignr,'?');
    toolbar(fignr,'off');
    f.background        = 1;                // black background
    f.figure_size       = [5 300];
    f.figure_name       = 'variometer';
    f.figure_position   = [700 300];

    // get min / max values of data
    drawlater();
    y_min = floor(min(data));   // rounds down to next integer
    y_max = ceil(max(data));    // rounds up to next integer

    if abs(y_min) > abs(y_max); // compare min/max values for having a symetrically y-axis
        y_scale = abs(y_min);
    else
        y_scale = abs(y_max);
    end

    // define the frame for the variometer

    x = -1;
    y = -y_scale;                  // <-- you may set the lower limit to a value of your purpose here
    w = 1;
    h =  y_scale;                  // <-- you may set the upper limit to a value of your purpose here

    rect=[x,y,w,h];
    plot2d(0,0,0,rect=rect);     
    a = gca();  
    a.visible = "on";
    a.box = "off";
    a.margins = [0.1,0.4,0.15,0.1];
    a.axes_visible = ["off","on","off"];
    a.x_location = "middle";
    a.y_location = "right";
    y_label = a.y_label;
    y_label.text = unit;
    a.y_label.font_angle = 0;
    a.y_label.position = [1.25 h+2];

    plot(CENTER(1), CENTER(2),'g+');
    e = gce();
    p = e.children(1);  // get the point as a handle
    p.mark_style = 1;
    p.mark_size = 6;
    drawnow();
    // display actual data

    for i=1:END;
        drawlater(); 
        if  i >1 & i < END+1;
            drawlater();
            delete(e);
        end;
        xpoly([-0.5 0.5],[data(i) data(i)],'lines',1);
        a = gca();
        a.axes_visible = ["off","on","off"];
        a.data_bounds = [x,y;w,h];
        e = a.children(1); 
        e.thickness = 3;  

        if data(i) < y*low_lim/100 | data(i) > h*up_lim/100;   // axes turn red if data value exceeds lower or upper scale limit
            a.foreground                = 5;            
            a.font_foreground           = 5;
            a.y_label.font_foreground   = 5;
        else

            a.foreground                = 7;            // normal display = yellow
            a.font_foreground           = 7;
            a.y_label.font_foreground   = 7;
        end

        drawnow(); 
        drawnow();
        tstep = 100;
        xpause(tstep*1000);  // xpause counts in microseconds, tstep is for milliseconds, thatswhy factor 1000
//
//        if  i < END
//            delete(e);
//        end
    end

endfunction


