//THIS FUNCTION WILL CREATE A VARIOMETER LIKE DISPLAY OF THE INPUT DATA
//
//var1: 1xn vector             --> data to be displayd
//var2: string                 --> data unit

// in comparison with "variometer.sci" this display will show a moving y-axis,
// while the xpoly-line stays in the middle of the display.

function variometer2 (data,unit)

END    = max(size(data));

fignr = 1010;       // use big numbers, so normal figures won't be affected

f = figure(fignr);
delmenu(fignr,'Datei');
delmenu(fignr,'Zusatzprogramme');
delmenu(fignr,'Editieren');
delmenu(fignr,'?');
toolbar(fignr,'off');
f.background        = 1;                // black background
f.figure_size       = [4 300];
f.figure_name       = 'variometer2';
f.figure_position   = [700 300];


x = -1;
y = 2;                // <-- you may set the scale borders here
w = 1;
h = 0.1;              // <-- use "h" to position the unit at the y-axis

// display actual data

for i=1:END;
    drawlater();
        if  i >1 & i < END+1;
            drawlater();
            delete(e1);
        end
     
    xpoly([-0.5 0.5],[data(i) data(i)],'lines',1);
    a = gca();
    a.x_location = "middle"
    a.y_location = "right";
    a.margins = [0.1,0.4,0.15,0.1];    
    a.axes_visible = ["off","on","off"];
    a.data_bounds = [x,data(i)-y;w,data(i)+y];
    a.tight_limits = "on";
    e1 = a.children(1); 
    e1.thickness = 2;  

    a.foreground                = 7;            // normal display = yellow
    a.font_foreground           = 7;
    a.font_size                 = 2;
    a.y_label.font_foreground   = 7;

    a.y_label.text = unit;
    a.y_label.font_angle = 0;
    a.y_label.position = [1.25 data(i)+y+h];
    a.ticks_format = ["","%.1f",""];
    drawnow(); 
    drawnow();
    // for checking purpose
    // mprintf('value = %.2f, lower scale = %.2f, upper scale = %.2f \n', data(i),data(i)-y,data(i)+y);
    tstep = 50;
    xpause(tstep*1000);  // xpause counts in microseconds, tstep is for milliseconds, thatswhy factor 1000
end

endfunction


