//THIS FUNCTION WILL CREATE A WIND ROSE LIKE DISPLAY OF THE INPUT DATA

function windrose(data);

    //data             --> data to be displayd

    // create a new figure and delete all the menues and the toolbox                
    fignr = 1004;       // use big numbers, so normal figures won't be affected

    f = figure(fignr);
    delmenu(fignr,'Datei');
    delmenu(fignr,'Zusatzprogramme');
    delmenu(fignr,'Editieren');
    delmenu(fignr,'?');
    toolbar(fignr,'off');

    // define display parameters here
    f.background = 3;
    f.figure_size = [350;350];
    f.figure_name = 'compass';
    f.figure_position = [200;200];

    END = max(size(data));

    // plot center point
    plot2d(0,0,-9);
    a = gca();
    a.axes_visible = ["off","off","off"];
    a.box = 'off';
    // define the main angular grid
    pts = [0:0.1:360];
    frame = pts/180*%pi;
    polarplot2(frame,1,1);                // this is to get the main grid plotted, although the outer arc wil be plotted twice
    a = gca();
    a.axes_reverse = ["off","on","off"];
    a.rotation_angles = [0,180];
    a.thickness = 1;
    // define the angular subgrid
    drawlater()
    subgrid = [0:5:360];
    for j = 1:max(size(subgrid));
        L1 = 0.96
        L2 = 0.92
        if modulo(j,2) == 0;
            xpoly([L1 1] * (cos(subgrid(j)*%pi/180)), [L1 1]*(sin((subgrid(j))*%pi/180)),'lines',0);
        else
            xpoly([L2 1] * (cos(subgrid(j)*%pi/180)), [L2 1]*(sin((subgrid(j))*%pi/180)),'lines',0);
        end
        e = gce();
        e.line_style = 1;
        e.thickness  = 1;
    end

    // define the needle

    needle_length   = 0.8;              // you may change needle length here
    needle_color    = 5;                // you may change the needle color here

    xset("color",needle_color);
    drawnow();
    
    for i=1:END;
    drawlater();
        if  i >1 & i < END+1;
            drawlater();
            delete(e);
        end
        xpoly([0 cos((data(i))*%pi/180)*needle_length],[0 sin((data(i))*%pi/180)*needle_length],'lines',0);   
        e = gce();
        e.line_style = 1;
        e.polyline_style = 4;           // define needle style here
        e.thickness = 2;                // define needle thickness here
    drawnow();
    drawnow();
        tstep = 50;
        xpause(tstep*1000);  // xpause counts in microseconds, tstep is for milliseconds, thatswhy factor 1000
    end;

endfunction;
